#### Linux From Scratch - Version 10.1-rc1

### Chapter 8. Installing Basic System Software

- Prev

  About Debugging Symbols

- Next

  Cleaning Up

- Up
- Home

# 8.77. Stripping Again

This section is optional. If the intended user is not a programmer and does not plan to do any debugging on the system software, the system size can be decreased by about 2 GB by removing the debugging symbols from binaries and libraries. This causes no inconvenience other than not being able to debug the software fully anymore.

Most people who use the commands mentioned below do not experience any difficulties. However, it is easy to make a typo and render the new system unusable, so before running the strip commands, it is a good idea to make a backup of the LFS system in its current state.

First place the debugging symbols for selected libraries in separate files. This debugging information is needed if running regression tests that use valgrind or gdb later in BLFS.

    save_lib="ld-2.33.so libc-2.33.so libpthread-2.33.so libthread_db-1.0.so"

    cd /lib

    for LIB in $save_lib; do
        objcopy --only-keep-debug $LIB $LIB.dbg
        strip --strip-unneeded $LIB
        objcopy --add-gnu-debuglink=$LIB.dbg $LIB
    done

    save_usrlib="libquadmath.so.0.0.0 libstdc++.so.6.0.28
                 libitm.so.1.0.0 libatomic.so.1.2.0"

    cd /usr/lib

    for LIB in $save_usrlib; do
        objcopy --only-keep-debug $LIB $LIB.dbg
        strip --strip-unneeded $LIB
        objcopy --add-gnu-debuglink=$LIB.dbg $LIB
    done

    unset LIB save_lib save_usrlib

Now the binaries and libraries can be stripped:

    find /usr/lib -type f -name \*.a \
       -exec strip --strip-debug {} ';'

    find /lib /usr/lib -type f -name \*.so* ! -name \*dbg \
       -exec strip --strip-unneeded {} ';'

    find /{bin,sbin} /usr/{bin,sbin,libexec} -type f \
        -exec strip --strip-all {} ';'

A large number of files will be reported as having their file format not recognized. These warnings can be safely ignored. These warnings indicate that those files are scripts instead of binaries.

- Prev

  About Debugging Symbols

- Next

  Cleaning Up

- Up
- Home